// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Animate.pas' rev: 6.00

#ifndef AnimateHPP
#define AnimateHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <RxTimer.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Animate
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TRxImageControl;
class PASCALIMPLEMENTATION TRxImageControl : public Controls::TGraphicControl 
{
	typedef Controls::TGraphicControl inherited;
	
private:
	bool FDrawing;
	bool FPaintBuffered;
	_RTL_CRITICAL_SECTION FLock;
	HIDESBASE MESSAGE void __fastcall WMPaint(Messages::TWMPaint &Message);
	
protected:
	Graphics::TGraphic* FGraphic;
	bool __fastcall DoPaletteChange(void);
	virtual void __fastcall DoPaintImage(void) = 0 ;
	void __fastcall DoPaintControl(void);
	void __fastcall PaintDesignRect(void);
	void __fastcall PaintImage(void);
	void __fastcall PictureChanged(void);
	void __fastcall Lock(void);
	void __fastcall Unlock(void);
	
public:
	__fastcall virtual TRxImageControl(Classes::TComponent* AOwner);
	__fastcall virtual ~TRxImageControl(void);
};


#pragma option push -b-
enum TGlyphOrientation { goHorizontal, goVertical };
#pragma option pop

class DELPHICLASS TAnimatedImage;
class PASCALIMPLEMENTATION TAnimatedImage : public TRxImageControl 
{
	typedef TRxImageControl inherited;
	
private:
	bool FActive;
	Graphics::TBitmap* FGlyph;
	int FImageWidth;
	int FImageHeight;
	int FInactiveGlyph;
	TGlyphOrientation FOrientation;
	Rxtimer::TRxTimer* FTimer;
	int FNumGlyphs;
	int FGlyphNum;
	bool FCenter;
	bool FStretch;
	Graphics::TColor FTransparentColor;
	bool FOpaque;
	bool FTimerRepaint;
	Classes::TNotifyEvent FOnFrameChanged;
	Classes::TNotifyEvent FOnStart;
	Classes::TNotifyEvent FOnStop;
	bool FAsyncDrawing;
	void __fastcall DefineBitmapSize(void);
	void __fastcall ResetImageBounds(void);
	unsigned __fastcall GetInterval(void);
	void __fastcall SetInterval(unsigned Value);
	void __fastcall SetActive(bool Value);
	void __fastcall SetAsyncDrawing(bool Value);
	void __fastcall SetCenter(bool Value);
	void __fastcall SetOrientation(TGlyphOrientation Value);
	void __fastcall SetGlyph(Graphics::TBitmap* Value);
	void __fastcall SetGlyphNum(int Value);
	void __fastcall SetInactiveGlyph(int Value);
	void __fastcall SetNumGlyphs(int Value);
	void __fastcall SetStretch(bool Value);
	void __fastcall SetTransparentColor(Graphics::TColor Value);
	void __fastcall SetOpaque(bool Value);
	void __fastcall ImageChanged(System::TObject* Sender);
	void __fastcall UpdateInactive(void);
	void __fastcall TimerExpired(System::TObject* Sender);
	bool __fastcall TransparentStored(void);
	MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	
protected:
	virtual bool __fastcall CanAutoSize(int &NewWidth, int &NewHeight);
	DYNAMIC HPALETTE __fastcall GetPalette(void);
	DYNAMIC void __fastcall AdjustSize(void);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Paint(void);
	virtual void __fastcall DoPaintImage(void);
	DYNAMIC void __fastcall FrameChanged(void);
	DYNAMIC void __fastcall Start(void);
	DYNAMIC void __fastcall Stop(void);
	
public:
	__fastcall virtual TAnimatedImage(Classes::TComponent* AOwner);
	__fastcall virtual ~TAnimatedImage(void);
	
__published:
	__property Align  = {default=0};
	__property Anchors  = {default=3};
	__property Constraints ;
	__property DragKind  = {default=0};
	__property AutoSize  = {default=1};
	__property bool AsyncDrawing = {read=FAsyncDrawing, write=SetAsyncDrawing, default=0};
	__property bool Active = {read=FActive, write=SetActive, default=0};
	__property bool Center = {read=FCenter, write=SetCenter, default=0};
	__property TGlyphOrientation Orientation = {read=FOrientation, write=SetOrientation, default=0};
	__property Graphics::TBitmap* Glyph = {read=FGlyph, write=SetGlyph};
	__property int GlyphNum = {read=FGlyphNum, write=SetGlyphNum, default=0};
	__property unsigned Interval = {read=GetInterval, write=SetInterval, default=100};
	__property int NumGlyphs = {read=FNumGlyphs, write=SetNumGlyphs, default=1};
	__property int InactiveGlyph = {read=FInactiveGlyph, write=SetInactiveGlyph, default=-1};
	__property Graphics::TColor TransparentColor = {read=FTransparentColor, write=SetTransparentColor, stored=TransparentStored, nodefault};
	__property bool Opaque = {read=FOpaque, write=SetOpaque, default=0};
	__property Color  = {default=-2147483643};
	__property Cursor  = {default=0};
	__property DragCursor  = {default=-12};
	__property DragMode  = {default=0};
	__property ParentColor  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ShowHint ;
	__property bool Stretch = {read=FStretch, write=SetStretch, default=1};
	__property Visible  = {default=1};
	__property OnClick ;
	__property OnDblClick ;
	__property OnMouseMove ;
	__property OnMouseDown ;
	__property OnMouseUp ;
	__property OnDragOver ;
	__property OnDragDrop ;
	__property OnEndDrag ;
	__property OnStartDrag ;
	__property OnEndDock ;
	__property OnStartDock ;
	__property OnContextPopup ;
	__property Classes::TNotifyEvent OnFrameChanged = {read=FOnFrameChanged, write=FOnFrameChanged};
	__property Classes::TNotifyEvent OnStart = {read=FOnStart, write=FOnStart};
	__property Classes::TNotifyEvent OnStop = {read=FOnStop, write=FOnStop};
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall HookBitmap(void);

}	/* namespace Animate */
using namespace Animate;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Animate
